VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Scope 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Scope"
   ClientHeight    =   4980
   ClientLeft      =   60
   ClientTop       =   390
   ClientWidth     =   9045
   LinkTopic       =   "Form1"
   ScaleHeight     =   332
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   603
   StartUpPosition =   3  'Windows Default
   Begin MSCommLib.MSComm Serial 
      Left            =   480
      Top             =   4080
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
   End
   Begin VB.CommandButton Quit 
      Caption         =   "Quit"
      Height          =   465
      Left            =   7485
      TabIndex        =   0
      Top             =   4140
      Width           =   1110
   End
End
Attribute VB_Name = "Scope"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim bits10 As Byte
Dim bits8 As Byte
Dim getpins As Byte
Dim setpins As Byte
Dim bytes_in() As Byte
Dim Adc(3) As Single
Dim stopped As Boolean
Sub get_bytes(n As Integer)
    buf n
    Serial.InputLen = n
    bytes_in() = Serial.Input
End Sub
'waits for buffer to hold i bytes
Sub buf(i As Integer)
    Dim j As Integer
    Do
       DoEvents
       j = Serial.InBufferCount
    Loop Until j >= i
End Sub

Sub send(a() As Byte)
    Serial.Output = a()
End Sub

Private Sub Form_Load()
Dim i As Integer
Show
Serial.Settings = "57600,n,8,1" 'make sure same baud as PIC settings
Serial.CommPort = 1
Serial.Handshaking = comNone          'no handshake
Serial.InputMode = comInputModeBinary 'not ASCII text
Serial.NullDiscard = False            'treat nulls as valid characters
Serial.PortOpen = True                'open port

bits10 = &H30   'encode 4 channels, return 8 bytes of 10-bit data
bits8 = &H40    'encode 4 channels, return 4 bytes of 8-bit data
getpins = &H50  'read input pins, return in lowe four bits
setpins = &H60  'add bit values in lower 4 bits - calculate each time

Print "Cannot find PIC"
Command setpins

Scale (0, 1)-(1000, -1)
Cls
stopped = False
Do Until stopped
   For i = 1 To 1000
      Adc10    'contains DoEvents
      PSet (i, Adc(0)), vbBlack
      PSet (i, Adc(1)), vbRed
      PSet (i, Adc(2)), vbBlue
      PSet (i, Adc(3)), vbGreen
   Next
   Cls
Loop
End
End Sub
Sub Command(a As Byte) 'will flush buffer if necessary, hang if no PIC
Dim b(0) As Byte
b(0) = a
send b()
Do
   get_bytes 1
Loop Until bytes_in(0) = a
End Sub

Private Sub Quit_Click()
stopped = True
End Sub
Sub Adc10()
Dim i As Integer
Command bits10
For i = 0 To 3
   get_bytes 2
   Adc(i) = (256! * (bytes_in(1) And 3) + bytes_in(0)) / 512! - 1
Next
End Sub
Sub Adc8()
Dim i As Integer
Command bits8
For i = 0 To 3
   get_bytes 1
   Adc(i) = bytes_in(0) / 128! - 1
Next
End Sub

Private Sub Serial_Click()

End Sub
